using Gtk;
using Tutorial;

namespace Tutorial {
	/* Heredamos de la clase boton para crear nuestro propio widget:
	 * http://references.valadoc.org/gtk+-2.0/Gtk.Button.html */
	public class MiBoton : Gtk.Button {
		/* Creamos una retrollamada para la senhal clicked de la clase boton:
		 * http://references.valadoc.org/gtk+-2.0/Gtk.Button.clicked.html */
		[Callback]
		public void on_clicked (MiBoton boton) {
			debug ("Cojones ya!");
		}
		
		public MiBoton () {
			label = "Hablamos del mileniarismo...";
			clicked += on_clicked;
		}
	}

	public class SimpleApp : Gtk.Window {
		/* Retrollamada para la senhal delete_event (cerrar la ventana):
		 * http://references.valadoc.org/gtk+-2.0/Gtk.Widget.delete_event.html
		 */
		[Callback]
		public bool on_delete_event (SimpleApp widget, Gdk.Event event) {
			Gtk.main_quit();
			return true;
		}
	
		public SimpleApp () {
			type = Gtk.WindowType.TOPLEVEL;
			
			/* Ahora usamos nuestro propio widget */
			var boton = new MiBoton ();
			add (boton);
			
			delete_event += on_delete_event;
			
			show_all ();
		}
	}
}

public static int main (string[] args) {
	Gtk.init (ref args); /* Inicializamos Gtk+ */
	
	var aplicacion = new SimpleApp ();
	
	Gtk.main (); /* Ejecutamos el bucle principal de la aplicacion */
	return 0;
}
